﻿using System.Collections.Generic;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace StackLayoutExmaple
{
    //**************************************
    //--------MinimumHeightRequest----------
    // File: WindowPopup.cs
    // Line: 83
    //**************************************
    public class MainPage : ContentPage
    {
        private WindowPopup windwoPopup;
        public MainPage()
        {
            windwoPopup = new WindowPopup();

            #region Frame
            var mainLayout = new Grid{
                ColumnSpacing=0,RowSpacing=0,
                HorizontalOptions = LayoutOptions.CenterAndExpand,
                VerticalOptions = LayoutOptions.CenterAndExpand,
                RowDefinitions =
                {
                    new RowDefinition{ Height= GridLength.Auto},
                    new RowDefinition{ Height= new GridLength(1,GridUnitType.Star )},
                }
            };
            #endregion Frame

            #region Title
            mainLayout.Children.Add(new ContentView
            {
                HorizontalOptions = LayoutOptions.CenterAndExpand,
                VerticalOptions = LayoutOptions.CenterAndExpand,
                BackgroundColor = Color.Red,
                Content = new Label {  
                    Text = "Example of MinimumHeightRequest",
                    TextColor = Color.White
                }
            }, 0, 0);
            #endregion Title

            #region Content
            var winpopButton = new Button {
                HorizontalOptions = LayoutOptions.CenterAndExpand,
                VerticalOptions = LayoutOptions.CenterAndExpand,
                HeightRequest = 50,
                Text = "Show Window",
            };
            winpopButton.Clicked += (s, e) => windwoPopup.Show();
            mainLayout.Children.Add(winpopButton, 0, 1);
            #endregion Content

            var rootLayout = new RelativeLayout {
                HorizontalOptions= LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Fill
            };
            rootLayout.Children.Add(mainLayout, 
                Constraint.Constant(0), 
                Constraint.Constant(0),
                Constraint.RelativeToParent(p=>p.Width),
                Constraint.RelativeToParent(p => p.Height));
            rootLayout.Children.Add(windwoPopup,
                Constraint.Constant(0),
                Constraint.RelativeToParent(p => (p.Height - 300) / 2),
                Constraint.RelativeToParent(p => p.Width)); 
            Content = rootLayout;
        }
    }
}
