﻿using System;
using Xamarin.Forms;

namespace StackLayoutExmaple
{
    //The MinimumHeightRequest : Line 83
    public class WindowPopup:ContentView
    {
        public WindowPopup()
        {
            HorizontalOptions = LayoutOptions.Center;
            VerticalOptions = LayoutOptions.Center;
            Padding = 5;
            Content = FrameRenderer();
        }

        #region Renderer
        private Grid FrameRenderer()
        {
            var contentWinPopup = new Grid
            {
                ColumnSpacing = 0,
                RowSpacing = 0,
                HorizontalOptions= LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Fill,
                RowDefinitions =
                {
                    new RowDefinition { Height= GridLength.Auto},
                    new RowDefinition{ Height= GridLength.Auto },
                    new RowDefinition{ Height= GridLength.Auto},
                }
            };

            contentWinPopup.Children.Add(new ContentView { Padding = -2, Content = new BoxView { Color = Color.Gray } },0,1,0,3);
            contentWinPopup.Children.Add(HeaderRenderer(), 0, 0);
            var contentView = ContentRenderer();
            contentWinPopup.Children.Add(ContentRenderer(), 0, 1);
            contentWinPopup.Children.Add(FooterRenderer(), 0, 2);
            return contentWinPopup;
        }
        private View HeaderRenderer()
        {
            var headerLayout = new Grid
            {
                ColumnSpacing = 0,
                RowSpacing = 0,
                HorizontalOptions = LayoutOptions.StartAndExpand,
                VerticalOptions = LayoutOptions.Center,
                ColumnDefinitions =
                {
                    new ColumnDefinition{ Width= new GridLength(1,GridUnitType.Star)},
                    new ColumnDefinition { Width = GridLength.Auto }
                }
            };

            headerLayout.Children.Add(new BoxView { Color = Color.Red, BackgroundColor = Color.Transparent }, 0, 2, 0, 1);
            var titleLabel = new Label
            {
                Text = "Advertencia",
                TextColor = Color.White,
                VerticalOptions = LayoutOptions.CenterAndExpand,
                HorizontalOptions = LayoutOptions.Start
            };
            headerLayout.Children.Add(new ContentView { Padding = 5, Content = titleLabel }, 0, 0);
            var closeButton = new Button
            {
                Text = "X",
                TextColor = Color.White,
                BackgroundColor = Color.Transparent,
                VerticalOptions = LayoutOptions.CenterAndExpand,
                HorizontalOptions = LayoutOptions.End
            };
            closeButton.Clicked += closeButton_Clicked; 
            headerLayout.Children.Add(new ContentView { Padding = 5, Content = closeButton }, 1, 0);
            return headerLayout;
       }
        private View ContentRenderer()
        {
            var contentView = new StackLayout { 
                HorizontalOptions= LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Fill,
//************************************************************************************************************
                MinimumHeightRequest=200, // Not found
//************************************************************************************************************
                BackgroundColor = Color.White,
                Children =
                {
                    new Label { Text = "nfkalfnlkasdjfaksdljfakj" }
                }
            };
            return contentView;
        }
        private View FooterRenderer()
        {
            var footerLayout = new StackLayout{
                Orientation = StackOrientation.Horizontal
            };
            return footerLayout;
        }
        #endregion Renderer

        public void Show()
        {
            this.ScaleTo(1, 1000,Easing.BounceOut);

        }
        private void closeButton_Clicked(object sender, EventArgs e)
        {
            this.ScaleTo(0, 500);
        }       
   }
}
